/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2006 Uta Schulze
 * Copyright (C) 2006 Max-Planck-Society
 */

%module alignment_tool
%{
#include "myalign_1best.h"
%}

%include "carrays.i" 
%include "exception.i"
%array_functions(int, intArray) ;
%array_functions(double, doubleArray) ;

%exception myalign {
  try{
    $action
  }
  catch (MyAlignException) {
      PyErr_SetString(PyExc_MemoryError,"Not enough memory!!");
      return NULL;
  }
}

class MyAlignException {};

struct penalty {
  int len ;
  double* limits ;
  double* penalties ;
  char* name ;
  int max_len ;
  int min_len ;
  char* transform ;
};

struct align_info {
  int* splice_align ;
  int* est_align ;
  int* mmatrix_param ;
  double* alignment_scores ;
  int* alignment_length ;
  int* aligned_dna ;
  int* aligned_est ;
};


struct align_info myalign(int nr_paths, const int mlen, int dna_len, char* dna, int est_len, char* est, struct penalty h, double* matchmatrix, double* donor, double* acceptor);


%pythoncode
%{

def createDoubleArrayFromList(list):
    array = new_doubleArray(len(list))
    for i in range(len(list)):
    	doubleArray_setitem(array, i, list[i])
    return array

def createListFromIntArray(array, array_len):
    list = [0]*array_len
    for i in range(array_len):
    	list[i] = intArray_getitem(array,i)
    return list

def createListFromDoubleArray(array, array_len):
    list = [0]*array_len
    for i in range(array_len):
    	list[i] = doubleArray_getitem(array,i)
    return list

%} 

