/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Written (W) 2004-2006 Uta Schulze
 * Written (W) 2004-2006 Bettina Hepp
 * Written (W) 2004-2006 Gunnar Raetsch
 * Copyright (C) 2004-2006 Fraunhofer Institute FIRST and Max-Planck-Society
 */

#ifndef _MYALIGN_H_
#define _MYALIGN_H_

#include <math.h>
#include <ctype.h>
#include <stdlib.h> 
#include <string.h>
#include <iostream>
//#include "Mathmatics.h"


class MyAlignException {};



struct ArrayElem //24B
{ 
  double score;
  int prev_j;
  int prev_i;
  int prev_matrix_no;   
  bool isSplice;
} ;

struct pre_score //24B
{
  double value; //8
  int prev_i; //4
  int prev_j; //4
  int prev_matrix_no;//4
  bool issplice;//4
};
typedef struct pre_score Pre_score;

struct penalty
{
  int len ;
  double* limits ;
  double* penalties ;
  char* name ;
  int max_len ;
  int min_len ;
  char* transform ;
};

struct align_info {
  int* splice_align ;
  int* est_align ;
  int* mmatrix_param ;
  double* alignment_scores ;
  int* alignment_length ;
  int* aligned_dna ;
  int* aligned_est ;
};

struct dnaest {
  int* DNA ;
  int* EST ;
};

//char  mapped to a number
int check_char(char base) ;

//according to the def. of a piecewise linear function f, we compute f(supp_value) 
double penalty_lookup(struct penalty h, double supp_value) ;

//"main" function, combines everything
struct align_info myalign(int nr_paths, const int mlen, int dna_len, char* dna, int est_len, char* est, struct penalty h, double* matchmatrix, double* donor, double* acceptor);

//fills the alignment matrix (or several, means, nr_paths many)
void fill_matrix(int nr_paths, Pre_score* matrices[], int est_len /*counter var: i*/, int dna_len /*counter var: j*/, char* est, char* dna, struct penalty h, double* matchmatrix, double* donor, double* acceptor, int nr_donor_sites, int* donor_sites, int* max_score_positions) ;

//does the backtracking for each alignment matrix (nr_paths many)
bool result_align (Pre_score* matrices[], int matrixnr, int i,  int j, int* result_length_ptr, char* est, char* dna, int* s_align, int* e_align, int* m_param, double* alignmentscores, int* max_score_positions );

#endif 
